diff --git a/src/display.c b/src/display.c
index 731062d7..72b56b6e 100644
--- a/src/display.c
+++ b/src/display.c
@@ -780,10 +780,11 @@ get_input(int prompt_position, struct key *key)
 	while (true) {
 		int delay = -1;
 
-		if (opt_refresh_mode == REFRESH_MODE_PERIODIC) {
+		if (opt_refresh_mode != REFRESH_MODE_MANUAL) {
 			bool refs_refreshed = false;
 
-			delay = watch_periodic(opt_refresh_interval);
+			if (opt_refresh_mode == REFRESH_MODE_PERIODIC)
+				delay = watch_periodic(opt_refresh_interval);
 
 			foreach_displayed_view (view, i) {
 				if (view_can_refresh(view) &&
diff --git a/src/watch.c b/src/watch.c
index 14f85b2f..49d30b8c 100644
--- a/src/watch.c
+++ b/src/watch.c
@@ -110,9 +110,13 @@ watch_index_handler(struct watch_handler *handler, enum watch_event event, enum
 		return check_file_mtime(&handler->last_modified, "%s/index", repo.git_dir)
 			? check : WATCH_NONE;
 
-	if (!check_file_mtime(&handler->last_modified, "%s/index", repo.git_dir) ||
-	    event == WATCH_EVENT_SWITCH_VIEW ||
-	    !index_diff(&diff, opt_show_untracked, false))
+	if (event == WATCH_EVENT_SWITCH_VIEW)
+		return WATCH_NONE;
+
+	if (check_file_mtime(&handler->last_modified, "%s/index", repo.git_dir))
+		return check;
+
+	if (!index_diff(&diff, opt_show_untracked, false))
 		return WATCH_NONE;
 
 	if (check & WATCH_INDEX_STAGED) {
